from datetime import timedelta

from data_gateway_sdk.protocols.smpm.smpm_ul_device_heat_group_meter_daily import SmpmUlDeviceHeatGroupMeterDailyData
from data_gateway_sdk.utils.buf_ref import BufRef


def test_smpm_ul_device_heat_group_meter_daily() -> None:
    case_serialized = bytes.fromhex("856400720600000072060000007206000000720600000000000000000000000000000000000000000000000000000000")
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=3.3, value_ch2=3.3, value_ch3=3.3, value_ch4=3.3, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=False, event_device_power_supply_enabled=False, event_device_common_settings_changed=False, event_device_measure_channels_settings_changed=False, event_device_digital_i_o_settings_changed=False, event_device_datetime_changed=False, event_device_ethernet_settings_changed=False, event_device_system_settings_changed1=False, event_device_system_settings_changed2=False, event_device_system_settings_changed3=False, event_device_system_settings_changed4=False, event_device_alarm_digital_input1=False, event_device_alarm_overrate_digital_input1=False, event_device_alarm_overrate_digital_input2=False, event_device_alarm_underrate_digital_input1=False, event_device_alarm_underrate_digital_input2=False, event_device_alarm_t_high_digital_input1=False, event_device_alarm_t_high_digital_input2=False, event_device_alarm_t_low_digital_input1=False, event_device_alarm_t_low_digital_input2=False, event_device_alarm_delta_t_high_digital_input1=False, event_device_alarm_delta_t_high_digital_input2=False, event_device_alarm_delta_t_low_digital_input1=False, event_device_alarm_delta_t_low_digital_input2=False, event_device_alarm_power_high_digital_input1=False, event_device_alarm_power_high_digital_input2=False, event_device_alarm_power_low_digital_input1=False, event_device_alarm_power_low_digital_input2=False, event_ch1_circuit_break_t_sensor_1=False, event_ch1_circuit_break_t_sensor_2=False, event_ch1_circuit_break_t_sensor_3=False, event_ch1_error_delta_t=False, event_ch1_consumption_lower_g_min_channel_rate_1=False, event_ch1_consumption_lower_g_min_channel_rate_2=False, event_ch1_consumption_lower_g_min_channel_rate_3=False, event_ch1_consumption_lower_g_max_channel_rate_1=False, event_ch1_consumption_lower_g_max_channel_rate_2=False, event_ch1_consumption_lower_g_max_channel_rate_3=False, event_ch1_no_coolant_channel_rate_1=False, event_ch1_no_coolant_channel_rate_2=False, event_ch1_no_coolant_channel_rate_3=False, event_ch1_circuit_break_stimulation_channel_rate_1=False, event_ch1_circuit_break_stimulation_channel_rate_2=False, event_ch1_circuit_break_pressure_sensor_1=False, event_ch1_circuit_break_pressure_sensor_2=False, event_ch1_circuit_break_pressure_sensor_3=False, event_ch1_reverse=False, event_ch2_circuit_break_t_sensor_1=False, event_ch2_circuit_break_t_sensor_2=False, event_ch2_circuit_break_t_sensor_3=False, event_ch2_error_delta_t=False, event_ch2_consumption_lower_g_min_channel_rate_1=False, event_ch2_consumption_lower_g_min_channel_rate_2=False, event_ch2_consumption_lower_g_min_channel_rate_3=False, event_ch2_consumption_lower_g_max_channel_rate_1=False, event_ch2_consumption_lower_g_max_channel_rate_2=False, event_ch2_consumption_lower_g_max_channel_rate_3=False, event_ch2_no_coolant_channel_rate_1=False, event_ch2_no_coolant_channel_rate_2=False, event_ch2_no_coolant_channel_rate_3=False, event_ch2_circuit_break_stimulation_channel_rate_1=False, event_ch2_circuit_break_stimulation_channel_rate_2=False, event_ch2_circuit_break_pressure_sensor_1=False, event_ch2_circuit_break_pressure_sensor_2=False, event_ch2_circuit_break_pressure_sensor_3=False, event_ch2_reverse=False, event_ch3_circuit_break_t_sensor_1=False, event_ch3_circuit_break_t_sensor_2=False, event_ch3_circuit_break_t_sensor_3=False, event_ch3_error_delta_t=False, event_ch3_consumption_lower_g_min_channel_rate_1=False, event_ch3_consumption_lower_g_min_channel_rate_2=False, event_ch3_consumption_lower_g_min_channel_rate_3=False, event_ch3_consumption_lower_g_max_channel_rate_1=False, event_ch3_consumption_lower_g_max_channel_rate_2=False, event_ch3_consumption_lower_g_max_channel_rate_3=False, event_ch3_no_coolant_channel_rate_1=False, event_ch3_no_coolant_channel_rate_2=False, event_ch3_no_coolant_channel_rate_3=False, event_ch3_circuit_break_stimulation_channel_rate_1=False, event_ch3_circuit_break_stimulation_channel_rate_2=False, event_ch3_circuit_break_pressure_sensor_1=False, event_ch3_circuit_break_pressure_sensor_2=False, event_ch3_circuit_break_pressure_sensor_3=False, event_ch3_reverse=False, event_ch4_circuit_break_t_sensor_1=False, event_ch4_circuit_break_t_sensor_2=False, event_ch4_circuit_break_t_sensor_3=False, event_ch4_error_delta_t=False, event_ch4_consumption_lower_g_min_channel_rate_1=False, event_ch4_consumption_lower_g_min_channel_rate_2=False, event_ch4_consumption_lower_g_min_channel_rate_3=False, event_ch4_consumption_lower_g_max_channel_rate_1=False, event_ch4_consumption_lower_g_max_channel_rate_2=False, event_ch4_consumption_lower_g_max_channel_rate_3=False, event_ch4_no_coolant_channel_rate_1=False, event_ch4_no_coolant_channel_rate_2=False, event_ch4_no_coolant_channel_rate_3=False, event_ch4_circuit_break_stimulation_channel_rate_1=False, event_ch4_circuit_break_stimulation_channel_rate_2=False, event_ch4_circuit_break_pressure_sensor_1=False, event_ch4_circuit_break_pressure_sensor_2=False, event_ch4_circuit_break_pressure_sensor_3=False, event_ch4_reverse=False) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=3.3, value_ch2=3.3, value_ch3=3.3, value_ch4=3.3, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=False, event_device_power_supply_enabled=False, event_device_common_settings_changed=False, event_device_measure_channels_settings_changed=False, event_device_digital_i_o_settings_changed=False, event_device_datetime_changed=False, event_device_ethernet_settings_changed=False, event_device_system_settings_changed1=False, event_device_system_settings_changed2=False, event_device_system_settings_changed3=False, event_device_system_settings_changed4=False, event_device_alarm_digital_input1=False, event_device_alarm_overrate_digital_input1=False, event_device_alarm_overrate_digital_input2=False, event_device_alarm_underrate_digital_input1=False, event_device_alarm_underrate_digital_input2=False, event_device_alarm_t_high_digital_input1=False, event_device_alarm_t_high_digital_input2=False, event_device_alarm_t_low_digital_input1=False, event_device_alarm_t_low_digital_input2=False, event_device_alarm_delta_t_high_digital_input1=False, event_device_alarm_delta_t_high_digital_input2=False, event_device_alarm_delta_t_low_digital_input1=False, event_device_alarm_delta_t_low_digital_input2=False, event_device_alarm_power_high_digital_input1=False, event_device_alarm_power_high_digital_input2=False, event_device_alarm_power_low_digital_input1=False, event_device_alarm_power_low_digital_input2=False, event_ch1_circuit_break_t_sensor_1=False, event_ch1_circuit_break_t_sensor_2=False, event_ch1_circuit_break_t_sensor_3=False, event_ch1_error_delta_t=False, event_ch1_consumption_lower_g_min_channel_rate_1=False, event_ch1_consumption_lower_g_min_channel_rate_2=False, event_ch1_consumption_lower_g_min_channel_rate_3=False, event_ch1_consumption_lower_g_max_channel_rate_1=False, event_ch1_consumption_lower_g_max_channel_rate_2=False, event_ch1_consumption_lower_g_max_channel_rate_3=False, event_ch1_no_coolant_channel_rate_1=False, event_ch1_no_coolant_channel_rate_2=False, event_ch1_no_coolant_channel_rate_3=False, event_ch1_circuit_break_stimulation_channel_rate_1=False, event_ch1_circuit_break_stimulation_channel_rate_2=False, event_ch1_circuit_break_pressure_sensor_1=False, event_ch1_circuit_break_pressure_sensor_2=False, event_ch1_circuit_break_pressure_sensor_3=False, event_ch1_reverse=False, event_ch2_circuit_break_t_sensor_1=False, event_ch2_circuit_break_t_sensor_2=False, event_ch2_circuit_break_t_sensor_3=False, event_ch2_error_delta_t=False, event_ch2_consumption_lower_g_min_channel_rate_1=False, event_ch2_consumption_lower_g_min_channel_rate_2=False, event_ch2_consumption_lower_g_min_channel_rate_3=False, event_ch2_consumption_lower_g_max_channel_rate_1=False, event_ch2_consumption_lower_g_max_channel_rate_2=False, event_ch2_consumption_lower_g_max_channel_rate_3=False, event_ch2_no_coolant_channel_rate_1=False, event_ch2_no_coolant_channel_rate_2=False, event_ch2_no_coolant_channel_rate_3=False, event_ch2_circuit_break_stimulation_channel_rate_1=False, event_ch2_circuit_break_stimulation_channel_rate_2=False, event_ch2_circuit_break_pressure_sensor_1=False, event_ch2_circuit_break_pressure_sensor_2=False, event_ch2_circuit_break_pressure_sensor_3=False, event_ch2_reverse=False, event_ch3_circuit_break_t_sensor_1=False, event_ch3_circuit_break_t_sensor_2=False, event_ch3_circuit_break_t_sensor_3=False, event_ch3_error_delta_t=False, event_ch3_consumption_lower_g_min_channel_rate_1=False, event_ch3_consumption_lower_g_min_channel_rate_2=False, event_ch3_consumption_lower_g_min_channel_rate_3=False, event_ch3_consumption_lower_g_max_channel_rate_1=False, event_ch3_consumption_lower_g_max_channel_rate_2=False, event_ch3_consumption_lower_g_max_channel_rate_3=False, event_ch3_no_coolant_channel_rate_1=False, event_ch3_no_coolant_channel_rate_2=False, event_ch3_no_coolant_channel_rate_3=False, event_ch3_circuit_break_stimulation_channel_rate_1=False, event_ch3_circuit_break_stimulation_channel_rate_2=False, event_ch3_circuit_break_pressure_sensor_1=False, event_ch3_circuit_break_pressure_sensor_2=False, event_ch3_circuit_break_pressure_sensor_3=False, event_ch3_reverse=False, event_ch4_circuit_break_t_sensor_1=False, event_ch4_circuit_break_t_sensor_2=False, event_ch4_circuit_break_t_sensor_3=False, event_ch4_error_delta_t=False, event_ch4_consumption_lower_g_min_channel_rate_1=False, event_ch4_consumption_lower_g_min_channel_rate_2=False, event_ch4_consumption_lower_g_min_channel_rate_3=False, event_ch4_consumption_lower_g_max_channel_rate_1=False, event_ch4_consumption_lower_g_max_channel_rate_2=False, event_ch4_consumption_lower_g_max_channel_rate_3=False, event_ch4_no_coolant_channel_rate_1=False, event_ch4_no_coolant_channel_rate_2=False, event_ch4_no_coolant_channel_rate_3=False, event_ch4_circuit_break_stimulation_channel_rate_1=False, event_ch4_circuit_break_stimulation_channel_rate_2=False, event_ch4_circuit_break_pressure_sensor_1=False, event_ch4_circuit_break_pressure_sensor_2=False, event_ch4_circuit_break_pressure_sensor_3=False, event_ch4_reverse=False))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85640000000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=0.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=0.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=0.0, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=0.0, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=0.0, value_ch4=2199023255.552))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=0.0))  # noqa: E501
    case_serialized = bytes.fromhex("85647e00000000000000000000000000000000000000000000000000000000000080ffffffffffffffffffffffff7f00")  # overflow
    assert SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), value_ch1=0.0, value_ch2=0.0, value_ch3=0.0, value_ch4=0.0, uptime_ch1=timedelta(seconds=0.0), uptime_ch2=timedelta(seconds=0.0), uptime_ch3=timedelta(seconds=0.0), uptime_ch4=timedelta(seconds=0.0), event_device_power_supply_lost=True, event_device_power_supply_enabled=True, event_device_common_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_digital_i_o_settings_changed=True, event_device_datetime_changed=True, event_device_ethernet_settings_changed=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_error_delta_t=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_reverse=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_error_delta_t=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_reverse=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_error_delta_t=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_reverse=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_error_delta_t=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_reverse=True) == SmpmUlDeviceHeatGroupMeterDailyData.parse(BufRef(case_serialized))  # noqa: E501
    assert case_serialized == SmpmUlDeviceHeatGroupMeterDailyData.serialize(SmpmUlDeviceHeatGroupMeterDailyData(days_ago=timedelta(seconds=5443200.0), event_ch1_circuit_break_pressure_sensor_1=True, event_ch1_circuit_break_pressure_sensor_2=True, event_ch1_circuit_break_pressure_sensor_3=True, event_ch1_circuit_break_stimulation_channel_rate_1=True, event_ch1_circuit_break_stimulation_channel_rate_2=True, event_ch1_circuit_break_t_sensor_1=True, event_ch1_circuit_break_t_sensor_2=True, event_ch1_circuit_break_t_sensor_3=True, event_ch1_consumption_lower_g_max_channel_rate_1=True, event_ch1_consumption_lower_g_max_channel_rate_2=True, event_ch1_consumption_lower_g_max_channel_rate_3=True, event_ch1_consumption_lower_g_min_channel_rate_1=True, event_ch1_consumption_lower_g_min_channel_rate_2=True, event_ch1_consumption_lower_g_min_channel_rate_3=True, event_ch1_error_delta_t=True, event_ch1_no_coolant_channel_rate_1=True, event_ch1_no_coolant_channel_rate_2=True, event_ch1_no_coolant_channel_rate_3=True, event_ch1_reverse=True, event_ch2_circuit_break_pressure_sensor_1=True, event_ch2_circuit_break_pressure_sensor_2=True, event_ch2_circuit_break_pressure_sensor_3=True, event_ch2_circuit_break_stimulation_channel_rate_1=True, event_ch2_circuit_break_stimulation_channel_rate_2=True, event_ch2_circuit_break_t_sensor_1=True, event_ch2_circuit_break_t_sensor_2=True, event_ch2_circuit_break_t_sensor_3=True, event_ch2_consumption_lower_g_max_channel_rate_1=True, event_ch2_consumption_lower_g_max_channel_rate_2=True, event_ch2_consumption_lower_g_max_channel_rate_3=True, event_ch2_consumption_lower_g_min_channel_rate_1=True, event_ch2_consumption_lower_g_min_channel_rate_2=True, event_ch2_consumption_lower_g_min_channel_rate_3=True, event_ch2_error_delta_t=True, event_ch2_no_coolant_channel_rate_1=True, event_ch2_no_coolant_channel_rate_2=True, event_ch2_no_coolant_channel_rate_3=True, event_ch2_reverse=True, event_ch3_circuit_break_pressure_sensor_1=True, event_ch3_circuit_break_pressure_sensor_2=True, event_ch3_circuit_break_pressure_sensor_3=True, event_ch3_circuit_break_stimulation_channel_rate_1=True, event_ch3_circuit_break_stimulation_channel_rate_2=True, event_ch3_circuit_break_t_sensor_1=True, event_ch3_circuit_break_t_sensor_2=True, event_ch3_circuit_break_t_sensor_3=True, event_ch3_consumption_lower_g_max_channel_rate_1=True, event_ch3_consumption_lower_g_max_channel_rate_2=True, event_ch3_consumption_lower_g_max_channel_rate_3=True, event_ch3_consumption_lower_g_min_channel_rate_1=True, event_ch3_consumption_lower_g_min_channel_rate_2=True, event_ch3_consumption_lower_g_min_channel_rate_3=True, event_ch3_error_delta_t=True, event_ch3_no_coolant_channel_rate_1=True, event_ch3_no_coolant_channel_rate_2=True, event_ch3_no_coolant_channel_rate_3=True, event_ch3_reverse=True, event_ch4_circuit_break_pressure_sensor_1=True, event_ch4_circuit_break_pressure_sensor_2=True, event_ch4_circuit_break_pressure_sensor_3=True, event_ch4_circuit_break_stimulation_channel_rate_1=True, event_ch4_circuit_break_stimulation_channel_rate_2=True, event_ch4_circuit_break_t_sensor_1=True, event_ch4_circuit_break_t_sensor_2=True, event_ch4_circuit_break_t_sensor_3=True, event_ch4_consumption_lower_g_max_channel_rate_1=True, event_ch4_consumption_lower_g_max_channel_rate_2=True, event_ch4_consumption_lower_g_max_channel_rate_3=True, event_ch4_consumption_lower_g_min_channel_rate_1=True, event_ch4_consumption_lower_g_min_channel_rate_2=True, event_ch4_consumption_lower_g_min_channel_rate_3=True, event_ch4_error_delta_t=True, event_ch4_no_coolant_channel_rate_1=True, event_ch4_no_coolant_channel_rate_2=True, event_ch4_no_coolant_channel_rate_3=True, event_ch4_reverse=True, event_device_alarm_delta_t_high_digital_input1=True, event_device_alarm_delta_t_high_digital_input2=True, event_device_alarm_delta_t_low_digital_input1=True, event_device_alarm_delta_t_low_digital_input2=True, event_device_alarm_digital_input1=True, event_device_alarm_overrate_digital_input1=True, event_device_alarm_overrate_digital_input2=True, event_device_alarm_power_high_digital_input1=True, event_device_alarm_power_high_digital_input2=True, event_device_alarm_power_low_digital_input1=True, event_device_alarm_power_low_digital_input2=True, event_device_alarm_t_high_digital_input1=True, event_device_alarm_t_high_digital_input2=True, event_device_alarm_t_low_digital_input1=True, event_device_alarm_t_low_digital_input2=True, event_device_alarm_underrate_digital_input1=True, event_device_alarm_underrate_digital_input2=True, event_device_common_settings_changed=True, event_device_datetime_changed=True, event_device_digital_i_o_settings_changed=True, event_device_ethernet_settings_changed=True, event_device_measure_channels_settings_changed=True, event_device_power_supply_enabled=True, event_device_power_supply_lost=True, event_device_system_settings_changed1=True, event_device_system_settings_changed2=True, event_device_system_settings_changed3=True, event_device_system_settings_changed4=True, uptime_ch1=timedelta(seconds=503316480.0), uptime_ch2=timedelta(seconds=503316480.0), uptime_ch3=timedelta(seconds=503316480.0), uptime_ch4=timedelta(seconds=503316480.0), value_ch1=2199023255.552, value_ch2=2199023255.552, value_ch3=2199023255.552, value_ch4=2199023255.552))  # noqa: E501
